program_name='QNAP_NVR_Demo'
(***********************************************************)
// CRESTED JANUS TECHNOLOGY LTD
(**********************************************************)
#include 'Buttons.axi'
define_device

dvTP        = 32001:1:0
vdvQNAP     = 33003:1:0
dvQNAP_NVR  = 0:4:0

define_constant

TP_STATUS = 119
TP_VERSION = 101

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)

define_variable

Constant dev DEVICE[] = 
{
    vdvQNAP,  dvTP

};

char g_buffer[256];
char QNAP_IP[15] = '192.168.1.104';  
char QNAP_USERNAME[15] = 'admin';  
char QNAP_PASSWORD[15] = 'admin';  

define_module
define_module 'QNAP_NVR'  NVR( DEVICE, dvQNAP_NVR, QNAP_IP, QNAP_USERNAME, QNAP_PASSWORD, BTN_COMMANDS, BTN_PTZ );

define_start
{
}
(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
define_event

data_event[dvTP]
{
  online:
  {
    send_command vdvQNAP, "'GET_VERSION ?'";
  }
}

button_event [dvTP, BTN_PRESET]
{
  push:
  {
    integer lst;
    
    lst = get_last( BTN_PRESET )
    send_command DEVICE[1], "'PRESET ', itoa( lst )"; 
  }
}

button_event [dvTP, BTN_LAYOUT]
{
  push:
  {
    integer lst;
    
    lst = get_last( BTN_LAYOUT )
    send_command DEVICE[1], "'LAYOUT ', itoa( lst )"; 
  }
}

button_event [dvTP, BTN_CHANNEL]
{
  push:
  {
    integer lst;
    
    lst = get_last( BTN_CHANNEL )
    send_command DEVICE[1], "'CHANNEL ', itoa( lst )"; 
  }
}

data_event[DEVICE]
{
  string:
  {
	char cmdHeader[30], 
		 value[100],
		 cmd[100], 
		 statusType[10], 
		 fbOutput[3], 
		 fbInput[3];
	
	while (find_string( data.text, ';',  1 ) > 0)
	{
	  cmd = remove_string( data.text, ';', 1 );
	  cmdHeader = remove_string( cmd, ' ', 1 );
	  value = left_string( cmd, length_string( cmd ) - 1);
	  switch (cmdHeader)
	  {

		case 'VERSION ':
		{
		  send_command dvTP, "'^TXT-',itoa( TP_VERSION ),',0,',value";
		}
		case 'STATUS ':
		{
		  statusType = remove_string( value, '=', 1 );
		  statusType = left_string( statusType, length_string( statusType ) - 1);
		  send_string 0:0:0, "statusType";
	        if (statusType == 'READY')
		  Send_Command dvTP, "'^BMF-',ItoA( TP_STATUS ),',0,%CF GREEN'";  
			else if (statusType == 'BUSY')
		  Send_Command dvTP, "'^BMF-',ItoA( TP_STATUS ),',0,%CF ORANGE'";  
			else if (statusType == 'ERROR')
		  Send_Command dvTP, "'^BMF-',ItoA( TP_STATUS ),',0,%CF RED'";  
		  
		  send_command dvTP, "'^TXT-',itoa( TP_STATUS ),',0,',value";
		}
		default :
		{
		}
	  }
	}
  }
}
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
define_program


